From 42065a7909a739bd37553b7cbf6e9f3ec181319b Mon Sep 17 00:00:00 2001
From: Gurjeet Singh <quic_gurjeets@quicinc.com>
Date: Sat, 12 Nov 2022 22:02:43 -0800
Subject: [PATCH 106/106] hack:vfio: iommu-driver not present

bypass set iommu failure

Change-Id: I8d92c347ae73d5a6aff1833c175c0c70a2add3ac
Signed-off-by: Manoj Vishwanathan <mvishwan@quicinc.com>
---
 drivers/misc/Kconfig |  2 ++
 drivers/vfio/vfio.c  | 13 ++++++++++---
 2 files changed, 12 insertions(+), 3 deletions(-)

diff --git a/drivers/misc/Kconfig b/drivers/misc/Kconfig
index 282fdd03b410..80ebd996827b 100644
--- a/drivers/misc/Kconfig
+++ b/drivers/misc/Kconfig
@@ -234,6 +234,7 @@ config QCOM_COINCELL
 config KIUMD
 	tristate "QCOM_KIUMD"
 	depends on ARCH_QCOM
+        default m
 	help
 	  This driver VFIO based kernel interface for user mode drivers to map DMA-BUF
 	  to device SMMU
@@ -241,6 +242,7 @@ config KIUMD
 config VFIO_IOMMU_QCOM
 	tristate "VFIO_IOMMU_QCOM"
 	depends on ARCH_QCOM && VFIO
+        default m
 	help
 	 This driver enables a VFIO IOMMU implementation for a VFIO
 	 prototype
diff --git a/drivers/vfio/vfio.c b/drivers/vfio/vfio.c
index a4555014bd1e..6a6149e18037 100644
--- a/drivers/vfio/vfio.c
+++ b/drivers/vfio/vfio.c
@@ -1061,6 +1061,7 @@ static long vfio_ioctl_set_iommu(struct vfio_container *container,
 	 */
 	if (list_empty(&container->group_list) || container->iommu_driver) {
 		up_write(&container->group_lock);
+		pr_err("%s: list_empty(&container->group_list):%d \n", __func__, list_empty(&container->group_list));
 		return -EINVAL;
 	}
 
@@ -1337,9 +1338,15 @@ static int vfio_group_get_device_fd(struct vfio_group *group, char *buf)
 	int fdno;
 	int ret = 0;
 
-	if (0 == atomic_read(&group->container_users) ||
-	    !group->container->iommu_driver || !vfio_group_viable(group))
-		return -EINVAL;
+	if (0 == atomic_read(&group->container_users))
+		pr_err("%s: 0 == atomic_read(&group->container_users)\n", __func__);
+	else if( !group->container->iommu_driver)
+		pr_err("%s: !group->container->iommu_driver\n", __func__);
+	else if(!vfio_group_viable(group))
+		{
+			pr_err("%s: (!vfio_group_viable(group))\n", __func__);
+			//return -EINVAL;
+		}
 
 	if (group->type == VFIO_NO_IOMMU && !capable(CAP_SYS_RAWIO))
 		return -EPERM;
-- 
2.17.1

